=== rts/lib/CMakeLists.txt ===

INCLUDE_DIRECTORIES(${CMAKE_SOURCE_DIR}/rts)

ADD_SUBDIRECTORY(lua)
ADD_SUBDIRECTORY(luasocket)
ADD_SUBDIRECTORY(7z)
ADD_SUBDIRECTORY(minizip)
ADD_SUBDIRECTORY(streflop)
ADD_SUBDIRECTORY(headlessStubs)
ADD_SUBDIRECTORY(assimp)

if    (NOT HEADLESS_SYSTEM)

	if    (USE_LIBSQUISH)
		ADD_SUBDIRECTORY(rg-etc1)
		ADD_SUBDIRECTORY(squish)
	endif (USE_LIBSQUISH)
endif (NOT HEADLESS_SYSTEM)
