=== debian/changelog ===
spring (98.0+dfsg-1) unstable; urgency=medium

  * Imported Upstream version 98.0+dfsg.
  * Declare compliance with Debian Policy 3.9.6.
  * Update VCS browser field to new canonical address.
  * Drop FTBFS-GCC-4.9.patch and cmake3.0.patch. Fixed upstream.
  * Remove unused lintian overrides for missing classpath warning.
  * Override lintian error shlib-with-non-pic-code (only on i386) because those
    files are not shared libraries but AI components of the Spring engine.

 -- Markus Koschany <apo@gambaru.de>  Sat, 11 Oct 2014 22:34:19 +0200

spring (97.0+dfsg-1) unstable; urgency=medium

  * Imported Upstream version 97.0+dfsg.
  * debian/watch: Remove lzma extension, use upstream's gzip compressed
    tarballs and avoid a bug with uscan.
  * Update get-orig-source target for new release.
  * Switch to SDL2. Build-depend on libsdl2-dev.
  * Update sdl-debian.patch for SDL2.
  * Add cmake3.0.patch:
    - Cherry pick upstream commit and support the latest cmake 3.0 release.
      Thanks to Felix Geyer for the report. (Closes: #758259)
  * Update debian/copyright for new release.

 -- Markus Koschany <apo@gambaru.de>  Sat, 16 Aug 2014 22:20:11 +0200

spring (96.0+dfsg-2) unstable; urgency=medium

  * Remove mention of oscpack from debian/copyright.
    - This directory does no longer exist.
  * Add FTBFS-GCC-4.9.patch.
    - Cherry pick upstream workaround to fix FTBFS with GCC 4.9.
      (Closes: #746914)
  * debian/control: Do not suggest libtxc-dxtn0 anymore.
    - This package is now recommended by libgl1-mesa-dri (Closes: #739183)

 -- Markus Koschany <apo@gambaru.de>  Sun, 01 Jun 2014 23:18:17 +0200
